<?php
namespace Fiscal\Entities;

class IntgNotafiscal extends Base\IntgNotafiscal
{
    const IDIMPORTADA_SIM = 'S';
    const IDIMPORTADA_NAO = 'N';

    const IDSTATUSNFE_UTILIZADO     = 'U';
    const IDSTATUSNFE_NAO_UTILIZADO = 'N';


    public function getFilial() {
        $filialId = array(
            "cdfilial"  => $this->getCdfilial(),
            "nrorg"     => $this->getNrorg(),
        );
        return \Geral\Entities\Filial::getObject($filialId);
    }

    public function getFilialRecebimento() {
        $filialId = array(
            "cdfili"  => $this->getCdfilirece(),
            "nrorg"     => $this->getNrorg(),
        );
        return \Geral\Entities\Filial::getObject($filialId);
    }

    public function getEmpresa() {
        $empresaId = array(
            "cdempresa" => $this->getCdempresa(),
            "nrorg"     => $this->getNrorg(),
        );
        return \Geral\Entities\Empresa::getObject($empresaId);
    }

    public function getInscricaoEstadual() {
        $increstadId = array(
            "cdincesta" => $this->getCdinscesta(),
            "cdempresa" => $this->getCdempresa(),
            "nrorg"     => $this->getNrorg(),
        );
        return \Geral\Entities\Inscrestad::getObject($increstadId);
    }

    /**
     * @return \Geral\Entities\Fornecedor
     */
    public function getFornecedor() {
        $fornecedorId = array(
            "cdforneced"    => $this->getCdforneced(),
            "nrorg"         => $this->getNrorg(),
        );
        return \Geral\Entities\Fornecedor::getObject($fornecedorId);
    }

    public function getModeloDocumentoFiscal() {
        $moddocfiscId = array(
            "cdmoddocfisc"  => $this->getCdmoddocfisc(),
            "nrorg"         => $this->getNrorg(),
        );
        return \Geral\Entities\Moddocfisc::getObject($moddocfiscId);
    }

    public function getSerieEntrada() {
        $serieentrId = array(
            "cdserieentr"   => $this->getCdserieentr(),
            "nrorg"         => $this->getNrorg(),
        );
        return \Geral\Entities\Serieentr::getObject($serieentrId);
    }

    public function foiImportada() {
        return $this->getIdimportada() === self::IDIMPORTADA_SIM;
    }

    /**
     * @param Notafiscal $notaFiscal
     * @return \Fiscal\Entities\IntgNotafiscal
     */
    public function marcarNotaFiscalComoImportada(Notafiscal $notaFiscal) {
        $this->setIdstatusnfe(self::IDSTATUSNFE_UTILIZADO);
        $this->setIdimportada(self::IDIMPORTADA_SIM);
        $this->setCdfilirece($notaFiscal->getFilirece()->getCdfilial());
        $this->setDtutilizaxml(new \DateTime());
        $this->setDtultatu(new \DateTime());
        return $this;
    }
}