<?php
namespace Geral\Repositories;

class Funcionario extends \Doctrine\ORM\EntityRepository
{
    public static function retornaFuncEquipes(){
      $sql = "SELECT FUN.NRPARCNEGOCIO AS LIDERADO, FUN.NMFUNC, OP.NRPARCNEGOCIO AS LIDER, OP.NMOPERADOR
                FROM FUNCIONARIO FUN , EQUIPETRAB EQ, OPERADOR OP, FUNCFAIXA, FAIXA_CARGO
               WHERE FUN.CDEQUIPETRAB = EQ.CDEQUIPETRAB
                 AND FUN.CDFUNC = FUNCFAIXA.CDFUNC
                 AND FUNCFAIXA.NRFAIXACARGO = FAIXA_CARGO.NRFAIXACARGO
                 AND  CDOPERADOR = EQ.CDOPERRESP
                 AND (FUN.CDCARGO = :P_CARGO OR :P_CARGO IS NULL)
                 AND (FAIXA_CARGO.NRFAIXACARGO = :P_NRFAIXACARGO OR :P_NRFAIXACARGO IS NULL)
                 AND (SYSDATE - FUN.DTEFETFUNC) / 30 > 6
                 AND FUN.NRPARCNEGOCIO <> OP.NRPARCNEGOCIO
                 AND FUN.DTDESLFUNC IS NULL
               ORDER BY LIDE";
        try {
            $retorno = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
            return $retorno;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
//    public static function retornaFuncEquipesCargo($param){
//      $sql = "SELECT FUN.NRPARCNEGOCIO AS LIDERADO,FUN.NMFUNC, OP.NRPARCNEGOCIO AS LIDER, OP.NMOPERADOR
//                FROM FUNCIONARIO FUN , EQUIPETRAB EQ, OPERADOR OP
//               WHERE FUN.CDEQUIPETRAB = EQ.CDEQUIPETRAB
//                 AND  CDOPERADOR = EQ.CDOPERRESP
//                 AND (FUN.CDCARGO = :P_CARGO OR :P_CARGO IS NULL)
//                 AND (FUN.NRFAIXACARGO = :P_NRFAIXACARGO OR :P_NRFAIXACARGO IS NULL)
//                 AND (SYSDATE - FUN.DTEFETFUNC) / 30 > 6
//                 AND FUN.NRPARCNEGOCIO <> OP.NRPARCNEGOCIO
//               ORDER BY LIDER";
//        try {
//            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $param);
//        } catch (\Exception $e) {
//            throw $e;
//        }
//    }
    public static function retornaFuncEquipesCargo($param){
      $sql = "SELECT FUN.NRPARCNEGOCIO AS LIDERADO, FUN.NMFUNC, OP.NRPARCNEGOCIO AS LIDER, OP.NMOPERADOR
                FROM FUNCIONARIO FUN , EQUIPETRAB EQ, OPERADOR OP, FUNCFAIXA, FAIXA_CARGO
               WHERE FUN.CDEQUIPETRAB = EQ.CDEQUIPETRAB
                 AND FUN.CDFUNC = FUNCFAIXA.CDFUNC
                 AND FUNCFAIXA.NRFAIXACARGO = FAIXA_CARGO.NRFAIXACARGO
                 AND  CDOPERADOR = EQ.CDOPERRESP
                 AND (FUN.CDCARGO = :P_CARGO OR :P_CARGO IS NULL)
                 AND (FAIXA_CARGO.NRFAIXACARGO = :P_NRFAIXACARGO OR :P_NRFAIXACARGO IS NULL)
                 AND (SYSDATE - FUN.DTEFETFUNC) / 30 > 6
                 AND FUN.NRPARCNEGOCIO <> OP.NRPARCNEGOCIO
                 AND FUN.DTDESLFUNC IS NULL
               ORDER BY LIDER";
        try {
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $param);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    
    public static function retornaLideradosEquipes($param){
      $sql = "SELECT FUN.NRPARCNEGOCIO
                FROM FUNCIONARIO FUN , EQUIPETRAB EQ, OPERADOR OP, FUNCFAIXA, FAIXA_CARGO
               WHERE FUN.CDEQUIPETRAB = EQ.CDEQUIPETRAB
                 AND FUN.CDFUNC = FUNCFAIXA.CDFUNC
                 AND FUNCFAIXA.NRFAIXACARGO = FAIXA_CARGO.NRFAIXACARGO
                 AND  CDOPERADOR = EQ.CDOPERRESP
                 AND (FUN.CDCARGO = :P_CARGO OR :P_CARGO IS NULL)
                 AND (FAIXA_CARGO.NRFAIXACARGO = :P_NRFAIXACARGO OR :P_NRFAIXACARGO IS NULL)
                 AND OP.NRPARCNEGOCIO <> 998
                 AND (SYSDATE - FUN.DTEFETFUNC) / 30 > 6
                 AND FUN.DTDESLFUNC IS NULL
               ORDER BY FUN.NRPARCNEGOCIO";
        try {
            $retorno = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $param);
            return $retorno;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public static function retornaCargoFaixaFuncionario($nrparcnegocio){
      $sql = "SELECT FUNCIONARIO.NRPARCNEGOCIO, FUNCIONARIO.NMFUNC, FUNCIONARIO.CDCARGO, FAIXA_CARGO.NRFAIXACARGO
                FROM FUNCIONARIO
               LEFT JOIN FUNCFAIXA
                  ON FUNCFAIXA.CDFUNC = FUNCIONARIO.CDFUNC
                 AND FUNCIONARIO.NRORG = FUNCFAIXA.NRORG
               LEFT JOIN FAIXA_CARGO
                  ON FAIXA_CARGO.NRFAIXACARGO = FUNCFAIXA.NRFAIXACARGO
               WHERE NRPARCNEGOCIO = $nrparcnegocio
                 AND FUNCIONARIO.DTDESLFUNC IS NULL";
        try {
            $retorno = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
            return $retorno;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public static function retornaDadosColaborador($cdperador){
      $sql = "SELECT F.NMFUNC, F.CDEMPRESA, F.CDFUNC, F.CDFILIAL, 
                     F.CDEQUIPETRAB, E.CDOPERRESP, O.CDOPERADOR
                FROM FUNCIONARIO F, EQUIPETRAB E, OPERADOR O
               WHERE F.CDEQUIPETRAB = E.CDEQUIPETRAB
                 AND F.CDFUNC       = O.CDFUNC
                 AND O.CDOPERADOR   = :CDOPERADOR";
      
      $param = array(":CDOPERADOR" => $cdperador);
        try {
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $param);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}