/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8175_CMPFUNO_EMITENTE.sql

Descrio:
Retorna o emitente da AF (destinatrio da NF).

Criao:
09/01/2004 Joo Fernando dos Reis Corra
*/

CREATE OR REPLACE
FUNCTION EMITENTE
  (P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE,
   P_CDPRODUTO  IN PRODUTO.CDPRODUTO%TYPE,
   P_CDFORNECED IN FORNECEDOR.CDFORNECED%TYPE) RETURN CHAR
IS
   V_IDEMITAFDES CHAR(1);
   V_CDEMPRESA   CHAR(2);
   V_CDARVPROD   CHAR(20);

BEGIN
   SELECT
      CDARVPROD
   INTO
      V_CDARVPROD
   FROM
      PRODUTO
   WHERE
      (CDPRODUTO = P_CDPRODUTO);

   SELECT
      MAX(EMITAFFORN.IDEMITAFFORN),
      MAX(EMITAFFORN.CDEMPRESA)
   INTO
      V_IDEMITAFDES,
      V_CDEMPRESA
   FROM
      EMITAFFORN,
      PRODUTO
   WHERE
      (EMITAFFORN.CDFILIAL   = P_CDFILIAL)           AND
      (EMITAFFORN.CDFORNECED = P_CDFORNECED)         AND
      (PRODUTO.CDPRODUTO     = EMITAFFORN.CDPRODUTO) AND
      (PRODUTO.CDARVPROD     = (SELECT
                                   MAX(P.CDARVPROD)
                                FROM
                                   EMITAFFORN E,
                                   PRODUTO P
                                WHERE
                                   (E.CDFILIAL   = P_CDFILIAL)   AND
                                   (E.CDFORNECED = P_CDFORNECED) AND
                                   (P.CDPRODUTO  = E.CDPRODUTO)  AND
                                   (INSTR(V_CDARVPROD, P.CDARVPROD) = 1)));

   IF V_IDEMITAFDES IS NULL THEN
      SELECT
         MAX(EMITENTEAF.IDEMITAFDES),
         MAX(EMITENTEAF.CDEMPRESA)
      INTO
         V_IDEMITAFDES,
         V_CDEMPRESA
      FROM
         EMITENTEAF,
         PRODUTO
      WHERE
         (EMITENTEAF.CDFILIAL = P_CDFILIAL)  AND
         (PRODUTO.CDPRODUTO   = EMITENTEAF.CDPRODUTO) AND
         (PRODUTO.CDARVPROD   = (SELECT
                                    MAX(P.CDARVPROD)
                                 FROM
                                    EMITENTEAF E,
                                    PRODUTO P
                                 WHERE
                                    (E.CDFILIAL  = P_CDFILIAL)  AND
                                    (P.CDPRODUTO = E.CDPRODUTO) AND
                                    (INSTR(V_CDARVPROD, P.CDARVPROD) = 1)));
   END IF;

   IF V_IDEMITAFDES IS NULL THEN
      SELECT
         MAX(PARCMPSUP.IDTIPEMITGER),
         MAX(PARCMPSUP.CDEMPRESA)
      INTO
         V_IDEMITAFDES,
         V_CDEMPRESA
      FROM
         PARCMPSUP
      WHERE
         (PARCMPSUP.CDFILIAL = P_CDFILIAL);
   END IF;

   IF (V_IDEMITAFDES = '1') OR (V_IDEMITAFDES = '3') THEN
      SELECT
         MAX(FILIAL.CDEMPRESA)
      INTO
         V_CDEMPRESA
      FROM
         FILIAL
      WHERE
         (CDFILIAL = P_CDFILIAL);
   END IF;

   RETURN (V_IDEMITAFDES || '_' || V_CDEMPRESA);
END;
/