/**
 * ETL da rea de Produto (Desenvolvimento) com dados de apropriao e de solicitaes
 *
 * @author Roberto Augusto Lopes Martins
 */

CREATE OR REPLACE
PROCEDURE ETL_DESENV 
  (P_DTINI IN DATE,
   P_DTFINA IN DATE)
IS
   V_DTINI DATE;
   V_DTFINA DATE;
   V_MES VARCHAR2(2);
   V_ANO VARCHAR2(4);
   V_BIM VARCHAR2(6);
   V_TRI VARCHAR2(6);
   V_SEM VARCHAR2(6);
   V_CDOPERADOR VARCHAR2(22);
   V_HRTRAB FLOAT;
   V_HRTRAB_CDA FLOAT;
   V_HRAPR FLOAT;
   V_HRPADR FLOAT;
   V_NRNUMERO FLOAT;
   V_CDEQUIPEIMPL VARCHAR2(10);
   V_NRDIASATRASO FLOAT;
   V_DTULTATUETL DATE;
BEGIN
   V_DTINI := TO_DATE('01'||TO_CHAR(P_DTINI,'MMYYYY'),'DD/MM/YYYY');
   V_MES := TO_CHAR(P_DTINI,'MM');
   V_ANO := TO_CHAR(P_DTINI,'YYYY');
   V_CDOPERADOR := '';
   DELETE FROM ETLDESENVAPR
    WHERE (CDANOBI > V_ANO)
       OR (CDANOBI = V_ANO AND CDMESBI >= V_MES);
   COMMIT;
   WHILE( V_DTINI <= P_DTFINA ) LOOP
      V_DTFINA := LAST_DAY(V_DTINI);
      V_MES := TO_CHAR(V_DTINI,'MM');
      V_ANO := TO_CHAR(V_DTINI,'YYYY');
      V_BIM := TO_CHAR(TRUNC((V_MES - 1) / 2) + 1)||' BIM';
      V_TRI := TO_CHAR(TRUNC((V_MES - 1) / 3) + 1)||' TRI';
      V_SEM := TO_CHAR(TRUNC((V_MES - 1) / 6) + 1)||' SEM';
      FOR C_APR IN (
         SELECT PO.CDPROCESSO  ,
                NVL(PL.CDEQUIPTRABPLAN,EQ.CDEQUIPETRAB) AS CDEQUIPETRAB,
                OP.CDOPERADOR  ,
                TRUNC((SUM(AP.DTFAPATIVTAR - AP.DTIAPATIVTAR)*24)*60) HORAS
           FROM APROATIVTARE AP, OPERADOR OP, FUNCIONARIO FU, PROCESSO PO,
                PLANATIVTARE PL, TAREFA TA, EQUIPETRAB EQ
          WHERE TRUNC(AP.DTIAPATIVTAR) BETWEEN V_DTINI AND V_DTFINA
            AND AP.CDOPERADOR = OP.CDOPERADOR
            AND PL.CDFILIAL = AP.CDFILIAL
            AND PL.NRTAREFA = AP.NRTAREFA
            AND PL.NRPLATIVTARE = AP.NRPLATIVTARE
            AND PL.CDFILIAL = TA.CDFILIAL
            AND PL.NRTAREFA = TA.NRTAREFA
            AND PL.CDPROCESSO = PO.CDPROCESSO
            AND OP.CDFUNC = FU.CDFUNC
            AND FU.CDEQUIPETRAB = EQ.CDEQUIPETRAB
            AND ((EQ.NMEQUIPETRAB LIKE 'DES%') OR (EQ.NMEQUIPETRAB LIKE 'P%') OR (EQ.NMEQUIPETRAB LIKE '%Qualidade%'))
          GROUP BY OP.CDOPERADOR, PO.CDPROCESSO, NVL(PL.CDEQUIPTRABPLAN,EQ.CDEQUIPETRAB)
          ORDER BY 3, 2)
      LOOP
         IF V_CDOPERADOR <> C_APR.CDOPERADOR||C_APR.CDEQUIPETRAB THEN
            SELECT TRUNC(MAX(S.TOTSAID - E.TOTENTR) * 60) AS HR
              INTO V_HRTRAB
              FROM (SELECT F.CDFUNC, CDEQUIPETRAB,
                           SUM((BP.DTBATIDAPTO - TRUNC(BP.DTBATIDAPTO))*24) TOTENTR
                      FROM BATIDAPONTO BP, OPERADOR OP, FUNCIONARIO F
                     WHERE BP.CDEMPRESA = OP.CDEMPRESA
                       AND BP.CDFUNC = OP.CDFUNC
                       AND OP.CDFUNC = F.CDFUNC
                       AND TRUNC(BP.DTBATIDAPTO) BETWEEN V_DTINI AND V_DTFINA
                       AND BP.IDSENTBATIDA = '1'
                       AND OP.CDOPERADOR = C_APR.CDOPERADOR
                       AND F.CDEQUIPETRAB = C_APR.CDEQUIPETRAB
                     GROUP BY F.CDFUNC, CDEQUIPETRAB) E ,
                   (SELECT F.CDFUNC, CDEQUIPETRAB,
                           SUM((BP.DTBATIDAPTO - TRUNC(BP.DTBATIDAPTO))*24) TOTSAID
                      FROM BATIDAPONTO BP, OPERADOR OP, FUNCIONARIO F
                     WHERE BP.CDEMPRESA = OP.CDEMPRESA
                       AND BP.CDFUNC = OP.CDFUNC
                       AND OP.CDFUNC = F.CDFUNC
                       AND TRUNC(BP.DTBATIDAPTO) BETWEEN V_DTINI AND V_DTFINA
                       AND OP.CDOPERADOR = C_APR.CDOPERADOR
                       AND F.CDEQUIPETRAB = C_APR.CDEQUIPETRAB
                       AND BP.IDSENTBATIDA = '2'
                     GROUP BY F.CDFUNC, CDEQUIPETRAB) S;
            SELECT NVL(SUM(HORACHAR_HORADEC(BP.QTHRTOTAL) *60), 0)
              INTO V_HRTRAB_CDA
              FROM SERVPREST BP, OPERADOR OP
             WHERE OP.CDOPERADOR = C_APR.CDOPERADOR
               AND BP.CDEMPRESA = OP.CDEMPRESA
               AND BP.CDFUNC = OP.CDFUNC
               AND TRUNC(BP.DTSERVPREST) BETWEEN V_DTINI AND V_DTFINA;
            V_HRTRAB := V_HRTRAB + V_HRTRAB_CDA;
            SELECT TRUNC((SUM(AP.DTFAPATIVTAR - AP.DTIAPATIVTAR)*24)*60) HORAS
              INTO V_HRAPR
              FROM APROATIVTARE AP, OPERADOR OP, FUNCIONARIO FU, PROCESSO PO,
                   PLANATIVTARE PL, TAREFA TA, EQUIPETRAB EQ
             WHERE TRUNC(AP.DTIAPATIVTAR) BETWEEN V_DTINI AND V_DTFINA
               AND AP.CDOPERADOR = OP.CDOPERADOR
               AND OP.CDOPERADOR = C_APR.CDOPERADOR
               AND PL.CDFILIAL = AP.CDFILIAL
               AND PL.NRTAREFA = AP.NRTAREFA
               AND PL.NRPLATIVTARE = AP.NRPLATIVTARE
               AND PL.CDFILIAL = TA.CDFILIAL
               AND PL.NRTAREFA = TA.NRTAREFA
               AND PL.CDPROCESSO = PO.CDPROCESSO
               AND OP.CDFUNC = FU.CDFUNC
               AND FU.CDEQUIPETRAB = EQ.CDEQUIPETRAB
               AND FU.CDEQUIPETRAB = C_APR.CDEQUIPETRAB
               AND ((EQ.NMEQUIPETRAB LIKE 'DES%') OR (EQ.NMEQUIPETRAB LIKE 'P%') OR (EQ.NMEQUIPETRAB LIKE '%Qualidade%'));
            IF (V_HRTRAB - V_HRAPR) > 0 THEN
               INSERT INTO ETLDESENVAPR (
                  CDPROCESSO, CDOPERADOR, CDEQUIPETRAB,
                  CDMESBI, CDANOBI,
                  BIMETLDESENV, TRIETLDESENV, SEMETLDESENV,
                  NRHRATIV, NRATIVAPR)
               VALUES (
                  'HR_N_APROP', C_APR.CDOPERADOR, C_APR.CDEQUIPETRAB,
                  V_MES, V_ANO,
                  V_BIM, V_TRI, V_SEM,
                  (V_HRTRAB - V_HRAPR), 0);
            END IF;
            SELECT MAX(DECODE(C.CDGRUPOCARGO, '17', 120, 160)) * 60
              INTO V_HRPADR
              FROM OPERADOR O, FUNCIONARIO F, CARGO C
             WHERE O.CDOPERADOR = C_APR.CDOPERADOR
               AND F.CDEQUIPETRAB = C_APR.CDEQUIPETRAB
               AND O.CDFUNC = F.CDFUNC
               AND F.CDCARGO = C.CDCARGO;
            IF (V_HRPADR - V_HRTRAB) > 0 THEN
               INSERT INTO ETLDESENVAPR (
                  CDPROCESSO, CDOPERADOR, CDEQUIPETRAB,
                  CDMESBI, CDANOBI,
                  BIMETLDESENV, TRIETLDESENV, SEMETLDESENV,
                  NRHRATIV, NRATIVAPR)
               VALUES(
                  'HR_N_TRABA', C_APR.CDOPERADOR, C_APR.CDEQUIPETRAB,
                  V_MES, V_ANO,
                  V_BIM, V_TRI, V_SEM,
                  (V_HRPADR - V_HRTRAB), 0);
            END IF;
         END IF;
         SELECT COUNT(*)
           INTO V_NRNUMERO
           FROM PLANATIVTARE PL
          WHERE PL.CDOPERRESP = C_APR.CDOPERADOR
            AND PL.CDPROCESSO = C_APR.CDPROCESSO
            AND PL.CDEQUIPTRABPLAN = C_APR.CDEQUIPETRAB
            AND TRUNC(PL.DTCONATIVTAR) BETWEEN V_DTINI AND V_DTFINA;
         INSERT INTO ETLDESENVAPR (
            CDPROCESSO, CDOPERADOR, CDEQUIPETRAB,
            CDMESBI, CDANOBI,
            BIMETLDESENV, TRIETLDESENV, SEMETLDESENV,
            NRHRATIV, NRATIVAPR)
         VALUES (
            C_APR.CDPROCESSO, C_APR.CDOPERADOR, C_APR.CDEQUIPETRAB,
            V_MES, V_ANO,
            V_BIM, V_TRI, V_SEM,
            C_APR.HORAS, V_NRNUMERO);
         V_CDOPERADOR := C_APR.CDOPERADOR||C_APR.CDEQUIPETRAB;
      END LOOP;
      FOR C_PROCESSO IN (
         SELECT PL.CDOPERRESP, NVL(PL.CDEQUIPTRABPLAN, F.CDEQUIPETRAB) AS CDEQUIPTRABPLAN, PL.CDPROCESSO, COUNT(*) AS NRNUMERO
           FROM PLANATIVTARE PL, OPERADOR OP, FUNCIONARIO F, EQUIPETRAB E
          WHERE PL.CDOPERRESP = OP.CDOPERADOR
            AND OP.CDFUNC = F.CDFUNC
            AND TRUNC(PL.DTCONATIVTAR) BETWEEN V_DTINI AND V_DTFINA
            AND E.CDEQUIPETRAB = NVL(PL.CDEQUIPTRABPLAN, F.CDEQUIPETRAB)
            AND ((E.NMEQUIPETRAB LIKE 'DES%') OR (E.NMEQUIPETRAB LIKE 'P%') OR (E.NMEQUIPETRAB LIKE '%Qualidade%'))
            AND NOT EXISTS (SELECT 1
                              FROM ETLDESENVAPR E
                             WHERE E.CDPROCESSO = PL.CDPROCESSO
                               AND E.CDOPERADOR = PL.CDOPERRESP
                               AND E.CDEQUIPETRAB = NVL(PL.CDEQUIPTRABPLAN, F.CDEQUIPETRAB)
                               AND E.CDANOBI = V_ANO
                               AND E.CDMESBI = V_MES)
          GROUP BY PL.CDOPERRESP, NVL(PL.CDEQUIPTRABPLAN, F.CDEQUIPETRAB), PL.CDPROCESSO)
      LOOP
         INSERT INTO ETLDESENVAPR (
            CDPROCESSO, CDOPERADOR, CDEQUIPETRAB,
            CDMESBI, CDANOBI,
            BIMETLDESENV, TRIETLDESENV, SEMETLDESENV,
            NRHRATIV, NRATIVAPR)
         VALUES (
            C_PROCESSO.CDPROCESSO, C_PROCESSO.CDOPERRESP, C_PROCESSO.CDEQUIPTRABPLAN,
            V_MES, V_ANO,
            V_BIM, V_TRI, V_SEM,
            0, C_PROCESSO.NRNUMERO);
      END LOOP;
      V_DTINI := ADD_MONTHS(V_DTINI,1);
      COMMIT;
   END LOOP;
   V_DTINI := TO_DATE('01/07/1999','DD/MM/YYYY');
   V_MES := TO_CHAR(V_DTINI,'MM');
   V_ANO := TO_CHAR(V_DTINI,'YYYY');
   SELECT MAX(DTULTATUETL)
     INTO V_DTULTATUETL
     FROM ETLDESENVSOL;
   DELETE FROM ETLDESENVSOL
    WHERE DTENCESOLI IS NULL;
   COMMIT;
   WHILE( V_DTINI <= P_DTFINA ) LOOP
      V_DTFINA := LAST_DAY(V_DTINI);
      V_MES := TO_CHAR(V_DTINI,'MM');
      V_ANO := TO_CHAR(V_DTINI,'YYYY');
      V_BIM := TO_CHAR(TRUNC((V_MES - 1) / 2) + 1)||' BIM';
      V_TRI := TO_CHAR(TRUNC((V_MES - 1) / 3) + 1)||' TRI';
      V_SEM := TO_CHAR(TRUNC((V_MES - 1) / 6) + 1)||' SEM';
      FOR C_SOL IN (
         SELECT S.CDCLIENTE, S.CDASSUNTO, S.CDOPERRESP, S.CDFILIAL, S.NRSOLISERV, S.DSREFESOLI, S.DTENCESOLI,
                E.CDEQUIPETRAB,
                DH.CDOPRESPIMPL, TO_CHAR(DH.DTLIBHOMO,'MM') AS CDMESLIBHOMO, TO_CHAR(DH.DTLIBHOMO,'YYYY') AS CDANOLIBHOMO,
                TO_CHAR(DC.DTLIBCLIE,'MM') AS CDMESLIBCLIE, TO_CHAR(DC.DTLIBCLIE,'YYYY') AS CDANOLIBCLIE,
                (SELECT SUM(PL.QTTEMPLAITAR)*60 AS NRTOTALHRPLA
                   FROM PLANATIVTARE PL, TAREFA TA
                  WHERE PL.CDFILIAL = TA.CDFILIAL
                    AND PL.NRTAREFA = TA.NRTAREFA
                    AND TA.CDFILIAL = S.CDFILIAL
                    AND TA.NRSOLISERV = S.NRSOLISERV
                    AND EXISTS (SELECT 1
                                  FROM PROCESGPROC PG
                                 WHERE PG.CDPROCESSO = PL.CDPROCESSO
                                   AND CDGRUPROCESSO = '00002')) AS NRTOTALHRPLA
           FROM SOLISERV S, EQUIPETRAB E, FUNCIONARIO F, OPERADOR O,
                (SELECT L.CDFILIAL, L.NRSOLISERV,
                        CDOPERADOR AS CDOPRESPIMPL,
                        DTALFASETRAM AS DTLIBHOMO
                   FROM LOGFASETRAM L
                  WHERE L.CDFASETRAM IN ('072', '272')
                    AND L.DTALFASETRAM = (SELECT MAX(DTALFASETRAM)
                                            FROM LOGFASETRAM D, OPERADOR O, FUNCIONARIO F
                                           WHERE D.CDFILIAL = L.CDFILIAL
                                             AND D.NRSOLISERV = L.NRSOLISERV
                                             AND D.CDFASETRAM IN ('072', '272')
                                             AND D.CDOPERADOR = O.CDOPERADOR
                                             AND O.CDFUNC = F.CDFUNC
                                             AND F.CDEQUIPETRAB <> '0000000030')) DH,
                (SELECT L.CDFILIAL, L.NRSOLISERV,
                        DTALFASETRAM AS DTLIBCLIE
                   FROM LOGFASETRAM L
                  WHERE L.CDFASETRAM IN ('061', '261')
                    AND L.DTALFASETRAM = (SELECT MAX(DTALFASETRAM)
                                            FROM LOGFASETRAM D
                                           WHERE D.CDFILIAL = L.CDFILIAL
                                             AND D.NRSOLISERV = L.NRSOLISERV
                                             AND D.CDFASETRAM IN ('061', '261'))) DC
          WHERE S.CDFILIAL = DH.CDFILIAL(+)
            AND S.NRSOLISERV = DH.NRSOLISERV(+)
            AND S.CDFILIAL = DC.CDFILIAL(+)
            AND S.NRSOLISERV = DC.NRSOLISERV(+)
            AND TRUNC(S.DTABERSOLI) BETWEEN V_DTINI AND V_DTFINA
            AND S.CDOPERRESP = O.CDOPERADOR
            AND O.CDFUNC = F.CDFUNC(+)
            AND F.CDEQUIPETRAB = E.CDEQUIPETRAB(+)
            AND ((S.DTENCESOLI IS NULL) OR (S.DTENCESOLI > V_DTULTATUETL) OR (V_DTULTATUETL IS NULL))
            AND ((S.CDASSUNTO BETWEEN '00010' AND '00200') OR (S.CDASSUNTO BETWEEN '00600' AND '00660')))
      LOOP
         V_CDEQUIPEIMPL := '';
         IF C_SOL.CDOPRESPIMPL IS NOT NULL THEN
            SELECT MAX(F.CDEQUIPETRAB)
              INTO V_CDEQUIPEIMPL
              FROM FUNCIONARIO F, OPERADOR O
             WHERE O.CDOPERADOR = C_SOL.CDOPRESPIMPL
               AND O.CDFUNC = F.CDFUNC;
         END IF;
         V_NRDIASATRASO := NULL;
         IF C_SOL.DTENCESOLI IS NULL THEN
            IF C_SOL.CDASSUNTO IN ('00012','00013','00014','00021','00022','00034','00041') THEN
               SELECT DECODE(MAX(TRUNC(DTALFASETRAM)),NULL,0,TRUNC(SYSDATE) - MAX(TRUNC(DTALFASETRAM)))
                 INTO V_NRDIASATRASO
                 FROM LOGFASETRAM L
                WHERE L.CDFILIAL = C_SOL.CDFILIAL
                  AND L.NRSOLISERV = C_SOL.NRSOLISERV
                  AND L.CDFASETRAM = '110'
                  AND NOT EXISTS (SELECT 1
                                    FROM LOGFASETRAM A
                                   WHERE A.CDFILIAL = L.CDFILIAL
                                     AND A.NRSOLISERV = L.NRSOLISERV
                                     AND A.CDFASETRAM IN ('050', '074', '250', '350'))
                  AND L.DTALFASETRAM = (SELECT MAX(DTALFASETRAM)
                                          FROM LOGFASETRAM D
                                         WHERE D.CDFILIAL = L.CDFILIAL
                                           AND D.NRSOLISERV = L.NRSOLISERV
                                           AND D.CDFASETRAM = '110');
            ELSIF C_SOL.CDASSUNTO IN ('00010','00011','00015','00016') THEN
               SELECT DECODE(MAX(TRUNC(DTALFASETRAM)),NULL,0,TRUNC(SYSDATE) - MAX(TRUNC(DTALFASETRAM)))
                 INTO V_NRDIASATRASO
                 FROM LOGFASETRAM L
                WHERE L.CDFILIAL = C_SOL.CDFILIAL
                  AND L.NRSOLISERV = C_SOL.NRSOLISERV
                  AND L.CDFASETRAM IN ('010','361','334')
                  AND NOT EXISTS (SELECT 1
                                    FROM LOGFASETRAM A
                                   WHERE A.CDFILIAL = L.CDFILIAL
                                     AND A.NRSOLISERV = L.NRSOLISERV
                                     AND A.CDFASETRAM IN ('105', '205')
                                     AND A.DTALFASETRAM > L.DTALFASETRAM)
                  AND L.DTALFASETRAM = (SELECT MAX(DTALFASETRAM)
                                          FROM LOGFASETRAM D
                                         WHERE D.CDFILIAL = L.CDFILIAL
                                           AND D.NRSOLISERV = L.NRSOLISERV
                                           AND D.CDFASETRAM IN ('010','361','334'));
            END IF;
            IF V_NRDIASATRASO = 0 THEN
               V_NRDIASATRASO := NULL;
            END IF;
         END IF;
         INSERT INTO ETLDESENVSOL (
            CDCLIENTE, CDASSUNTO, CDEQUIPERESP, CDOPERRESP, CDEQUIPEIMPL,
            CDOPRESPIMPL, NRSOLISERV, DTENCESOLI, DSREFESOLI, CDMESLIBHOMO,
            CDANOLIBHOMO, CDMESLIBCLIE, CDANOLIBCLIE, CDMESBI, CDANOBI,
            BIMETLDESENV, TRIETLDESENV, SEMETLDESENV, NRQTSOLISERV, NRDIASATRASO,
            NRTOTALHRPLA, DTULTATUETL)
         VALUES (
            C_SOL.CDCLIENTE, C_SOL.CDASSUNTO, C_SOL.CDEQUIPETRAB, C_SOL.CDOPERRESP, V_CDEQUIPEIMPL,
            C_SOL.CDOPRESPIMPL, C_SOL.NRSOLISERV, C_SOL.DTENCESOLI, C_SOL.DSREFESOLI, C_SOL.CDMESLIBHOMO,
            C_SOL.CDANOLIBHOMO, C_SOL.CDMESLIBCLIE, C_SOL.CDANOLIBCLIE, V_MES, V_ANO,
            V_BIM, V_TRI, V_SEM, 1, V_NRDIASATRASO,
            C_SOL.NRTOTALHRPLA, SYSDATE);
      END LOOP;
      V_DTINI := ADD_MONTHS(V_DTINI,1);
      COMMIT;
   END LOOP;
END;
/ 
