var Dfe18500_DocumentosParaComposicaoDeCustos_Controller = function(General, ScreenService, templateManager, ZhFilterPreferences, ZHPromise, metaDataFactory, eventEngine, MessageService) {
    
    var widgetCabecalhoEntrada;
    
    this.fieldFilterOnChange = function() {
        var widget = templateManager.container.getActiveWidget();
        
        widget.reload();
    };

    this.setCabecalhoWidgetEntrada = function(widget) {
        widgetCabecalhoEntrada =  widget;
    };
    
    this.getCabecalhoWidgetEntrada = function() {
        return widgetCabecalhoEntrada;
    };
    
    this.getFieldValueNotaFiscalOrigem = function(name) {
        if (widgetCabecalhoEntrada && widgetCabecalhoEntrada.currentRow) 
			return widgetCabecalhoEntrada.currentRow[name];
		else 
			return "";
		
    };
    
    this.actConfirmarOnClick = function(args) {
        var documentosWidget = args.owner.widget;
        var rateioCustosWidget = templateManager.container.getWidget("rateioCustos");
        
        General.callRestEngine("df_entrada#/salvarDocumento", "DataSet", documentosWidget.getCheckedRows()).then((response) => {
            MessageService.successNotificationByCode('REGISTRO_SALVO');
            documentosWidget.unSelectAll();
            documentosWidget.reload();
            rateioCustosWidget.activate();
        });
        
    };
    
    
    this.salvaWidgetOnSaveInlineEdit = function(widget) {
        const vrrateioAlterados = widget.dataSource.data.filter(row =>  !!('changed_VRRATEIO' in row));
        
        General.callRestEngine("df_entrada#/salvaRateioIt", "DataSet", widget.dataSource.data).then((response) => {
            
            MessageService.successNotificationByCode('REGISTRO_SALVO');
            
            vrrateioAlterados.forEach(function(rateio){
                rateio.__is_new = false;
                delete rateio.changed_VRRATEIO;
                delete rateio.changed;
            });
            
            widget.list();
        }).catch((error) => {
            MessageService.showMessageByCode(error.data.error);
            
        });
    };
    
    
    this.actConfirmarComposicaoOnClick = function(args) {
        var row = { "CDFILIAL": this.getFieldValueNotaFiscalOrigem("CDFILIAL"),
                    "NRLANCTONF": this.getFieldValueNotaFiscalOrigem("NRLANCTONF"),
                    "NRORG": this.getFieldValueNotaFiscalOrigem("NRORG")
        };
        
        General.callRestEngine("df_entrada#/confirmarComposicao", "Row", row).then(() => {
            MessageService.showMessageByCode('CONFIRMA_COMPOSICAO');
            ScreenService.openWindow('df_entrada#dfe11000_lancamento_entrada');
        });
        
    };
    
    this.actExcluirDocumentoRelacionado = function(args) {
        var documentosRelacionadosWidget = args.owner.widget;

        General.callRestEngine("df_entrada#/excluirDocumento", "DataSet", documentosRelacionadosWidget.getCheckedRows()).then((response) => {
            MessageService.showMessageByCode('REGISTRO_EXCLUIDO');
            documentosRelacionadosWidget.unSelectAll();
            documentosRelacionadosWidget.reload();

        });
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Dfe18500_DocumentosParaComposicaoDeCustos_Controller', Dfe18500_DocumentosParaComposicaoDeCustos_Controller);
});