function CodigoSituacaoOperacaoSimples() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const protractorHelper = require('protractor-helper');

	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		z.component.menu.clickByPath(['Parametrização', 'Documentos Fiscais',
			'Código de Situação de Operação do Simples Nacional']);
		geral.esperarLoading();
	};

	this.filta = (empresa, inscEstadual, entadaSaida, tipoOperacao) => {
		geral.searchAndClickGridField('NMRAZSOCEMPR', empresa, 'NMRAZSOCEMPR');
		geral.searchAndClickGridField('CDINSCESTA', inscEstadual, 'CDINSCESTA');
		geral.selectNative('IDENTSAICSOSN', entadaSaida);
		geral.searchAndClickGridField('NMTIPOOPER', tipoOperacao, 'NMTIPOOPER');
	};

	this.adicionar = (produto, CSOSN, grupoFiscal, operInterestadual) => {
		protractorHelper.click(element(by.css('#NMPRODUTO .editable')));
		geral.searchAndClickGridField('NMPRODUTO', produto, 'NMPRODUTO');
		geral.selectNative('CDFISCOPERSN', CSOSN);
		protractorHelper.click(element(by.css('#DSGRUPOFISC .editable')));
		geral.searchAndClickGridField('DSGRUPOFISC', grupoFiscal, 'DSGRUPOFISC');
		geral.selectNative('IDCSOSNINTEREST', operInterestadual);
	};

	this.editar = (produto, CSOSN, grupoFiscal, operInterestadual) => {
		geral.clickLimparAutoComplete('NMPRODUTO');
		protractorHelper.click(element(by.css('#NMPRODUTO .editable')));
		geral.searchAndClickGridField('NMPRODUTO', produto, 'NMPRODUTO');
		geral.selectNative('CDFISCOPERSN', CSOSN);
		geral.clickLimparAutoComplete('DSGRUPOFISC');
		protractorHelper.click(element(by.css('#DSGRUPOFISC .editable')));
		geral.searchAndClickGridField('DSGRUPOFISC', grupoFiscal, 'DSGRUPOFISC');
		geral.selectNative('IDCSOSNINTEREST', operInterestadual);
	};
}

module.exports = new CodigoSituacaoOperacaoSimples();
